Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: enhancing/improving Estimated time: 0.00 hour

Target version: CoCoA-5.4.4 Spent time: 0.20 hour

Description

I have noticed that error messages produced by fns which are defined in BuiltinOneLiners are less precise than those defined in 

BuiltinFunctions-CoCoALib.

Less precise because they do not indicate which is bad arg; they simply indicate the whole fn call expression.

Can we find a way to make them more precise?

Related issues:

Related to CoCoA-5 - Support #1621: Doc for the various BuiltIn files New 18 Oct 2021

Related to CoCoALib - Feature #743: Better errors: give supplementary info ab... In Progress 30 Jun 2015

History

#1 - 18 Oct 2021 11:30 - John Abbott

I have set the target version as 5.3.4, but this may be wildly optimistic.

I fear that this request may be rather hard, or even impossible (without making BuiltinOneLiners much more complicated).

#2 - 18 Oct 2021 11:30 - John Abbott

- Related to Support #1621: Doc for the various BuiltIn files added

#3 - 18 Oct 2021 11:33 - John Abbott

Here is an example of what I mean:

/**/ pi := 3.14159;

/**/ CFApprox(pi,2);

--> ERROR: Expecting type RAT, but found type INT

--> CFApprox(pi,2);

-->             ^

/**/ CFApprox(pi,3/2);

--> ERROR: The arg(s) given are unsuitable

--> [CoCoALib] CFApprox: relative error must be between 0 and 1

--> CFApprox(pi,3/2);

--> ^^^^^^^^^^^^^^^^

 

The 2nd arg must be a rational between 0 and 1.  In the first case the troublesome arg is identified; in the second just the whole call is highlighted.
#4 - 12 Nov 2021 11:05 - John Abbott

- Subject changed from BuiltinOneLiners to BuiltinOneLiners -- less precise location in error messages

#5 - 19 Nov 2021 17:02 - Anna Maria Bigatti

I believe that the error must be clear enough in CoCoALib so that there is no need to intercept (all??) situations like this.

#6 - 19 Nov 2021 17:03 - Anna Maria Bigatti

- Related to Feature #743: Better errors: give supplementary info about the error added

#7 - 03 Feb 2022 19:55 - John Abbott

- Target version changed from CoCoA-5.4.0 to CoCoA-5.4.2

#8 - 18 Mar 2024 21:16 - John Abbott

- Target version changed from CoCoA-5.4.2 to CoCoA-5.4.4
